//'Pacman 3d' - sample game for summer 2008 '100 lines' contest
//Created by Vadim647
#include <acknex.h>
#include <default.c>
SOUND* eat = "eat.wav";
SOUND* die = "die.wav";
var game_speed = 1.6;	//game speed. used for making game more interesting. 1.6 -> default.
var camera_v;			//camera.arc changing variable.
var t_i;				//temp_integer
var points;				//number of 'dots' remaining in the level
VECTOR t_v;				//temp_vector
STRING* t_s="#60";		//temp_string
ENTITY* level;
PANEL* about_panel = 
{	//small panel containing some info about game
	digits(8,8,"Pacman 3d\n'100 lines' game\nLiteC project\nCreated by Vadim647\n\nW,A,S,D - movement\nEat all dots","Arail#20bi",1,0);
	flags = VISIBLE;
}
function pml_load(STRING* levelname);//make sure that it will be usable from everywhere in code
function pos_movement(dir,amount)	//check, if it's possible to move to point,
{									//offset by .amount. towards .dir.ection
	c_trace(vector(amount*cosv(dir)+my.x,amount*sinv(dir)+my.y,0+my.z),vector(amount*cosv(dir)+my.x,amount*sinv(dir)+my.y,0+my.z-512),IGNORE_PASSABLE);
	return(trace_hit);
}
function make_movement(dir,amount)	//check by previos functoin and set movement variables
{
	if (pos_movement(dir,amount)) {my.skill21 = amount;my.skill22 = ang(dir);return(0);} else {return(1);}
}
function direction_mind()	//function to randomize movement of monsters/ghosts
{							//its easy to understand
	if (my.skill22==0||my.skill22==180||my.skill22==-180)
	{
		if (random(3)<1) make_movement(90,32);
		if (random(3)<1) make_movement(270,32);
	}
	else
	{
		if (random(3)<1) make_movement(0,32);
		if (random(3)<1) make_movement(180,32);
	}
}
function ent_rotate(rotate_angle,rotate_speed)	//function for smooth rotating.
{
	var rotate_result;
	if (my.pan == rotate_angle) { return; }
	rotate_result = ang(rotate_angle - my.pan);
	if (rotate_result > 0) {c_rotate(my,vector( rotate_speed * time_step,0,0), IGNORE_PASSABLE);}
	if (rotate_result < 0) {c_rotate(my,vector(-rotate_speed * time_step,0,0), IGNORE_PASSABLE);}
	if (ang(rotate_angle - my.pan) < 0 && rotate_result > 0){
		c_rotate(my,vector(rotate_angle - my.pan,0,0),IGNORE_PASSABLE);}
	if (ang(rotate_angle - my.pan) > 0 && rotate_result < 0){
		c_rotate(my,vector(rotate_angle - my.pan,0,0),IGNORE_PASSABLE);}
}

action point()	//the 'dots' (things that pacman likes to eat.)
{
	set(my,PASSABLE);													//so monsters will not stuck with it.
	while (vec_dist(my.x,player.x)>8) {my.pan += time_step*4;wait(1);}	//way to avoid colision using.
	points -= 1;snd_play(eat,50,50);ent_remove(me);											//pacman 'eats' it and its removed.
}
action monster()	//some kind of AI for pacman. This one is enough for 100 lines game.
{
	set(my,PASSABLE);//passable too. no real reason for it, because all c_move functions are replaced by vec_add
	while (1)
	{
		my.skill24 = cycle(my.skill24+1.5,0,100);	//animation cycle.
		if (my.skill21>0)	//skill21 -> points to move towards skill22.
		{	//c_move alternative (it's a packman game, so colision isn't realy needed)
			vec_add(my.x,vector(game_speed*cos(my.skill22),game_speed*sin(my.skill22),0));
			my.skill21 -= game_speed;//reduce total points by covered distance
		}
		if (my.skill21<=0)
		{
			direction_mind();//lets think about moving somewhere
			if (my.skill21==0) make_movement(my.skill22,32);//or move in current direction
			if (my.skill21==0) {my.skill22+=180;direction_mind();}//if still stuck, try rotating 180 degrees.
		}
		ent_animate(me,"monster",my.skill24,ANM_CYCLE);	//animate the entity
		if (vec_dist(my.x,player.x)<16) {set(player,FLAG1);}//if it meets packman, its a bad day for packman
		wait(1);
	}
}
action packman()	//the 'packman' itself, controlled by player
{
	player = me;set(my,PASSABLE);//same system :)
	while (1)
	{
		while(!(is(my,FLAG1)))	//while it havent contact with monsters, we can control it
		{
		my.skill24 = cycle(my.skill24+game_speed,0,100);//same animation cycle system
		ent_rotate(my.skill22,15);//and don't forget to rotate it.
		//
		if (my.skill21>0)
		{	//c_move alternative (it's a packman, so colision isn't realy needed)
			vec_add(my.x,vector(game_speed*cos(my.skill22),game_speed*sin(my.skill22),0));
			my.skill21 -= game_speed;//reduce total points by covered distance
		}
		if (my.skill21<=0)
		{	//now player can choose direction to move.
			if (key_w) make_movement(0,32);
			if (key_d) make_movement(270,32);
			if (key_a) make_movement(90,32);
			if (key_s) make_movement(180,32);
			if (my.skill21==0) make_movement(my.skill22,32);//if player forgot to press something, continue moving
		}
		ent_animate(me,"packman",my.skill24,ANM_CYCLE);//animation
		wait(1);
		}
		my.skill21 = 0;							//make sure it wouldn't move after 'reincarnation'
		set(my,PASSABLE|TRANSLUCENT);			//make it translucent
		my.alpha = 100;
		snd_play(die,50,50);
		while (my.alpha > 0)					//
		{										//
			my.alpha -= time_step * 10;			//
			wait(1);							//
		}										//^^^fade-out
		wait(-0.5);								//some pause
		reset(my,PASSABLE|TRANSLUCENT|FLAG1);	//and it's alive again!
		vec_set(my.x,nullvector);				//reset position (it makes level building a little bit harder)
		wait(1);
	}
}

//My idea to use models instead of WMB levels, while it's still possible to set entitys positions on level.
function tvts(STRING* str1,strv)		//function for cutting line count.
{
	vec_set(t_v,nullvector);			//reset vector (so it wouldn't find previos used)
	str_cpy(t_s,str1);					//copy bone name
	str_cat_num(t_s,"%.0f",strv);		//add ent/bone number
	vec_for_bone(t_v,level,t_s);			//and set temp_vector to its position
}
function bte_load(STRING* str,STRING* mdl,action* act)
{
	t_i = 1;
	tvts(str,t_i);
	while (vec_dist(t_v,nullvector)>0)
	{
		ent_create(mdl,t_v,act);
		t_i++;
		tvts(str,t_i);//^++
	}
	t_i--;
}
function pml_load(STRING* levelname)
{
	level_load(NULL);	//reset the level
	wait(3);			//wait 3 frames (for engine versions <7.06)
	level = ent_create(levelname,vector(0,0,-0.1),NULL);set(level,POLYGON);c_setminmax(level);//load a level
	ent_create("packman.mdl",vector(0,0,0),packman);//create the packman at center.
	vec_set(camera.pan,vector(30,-60,0));	//change camera position
	vec_set(camera.x,vector(-322,-149,516));//used fixed numbers because it takes less place
	bte_load("point","point.mdl",point);
	points = t_i;
	bte_load("monster","monster.mdl",monster);
	while (points>0) {wait(1);}//wait until the pacman will eat everything tasty on level
	level_load("Final.mdl");//load a screenie (because I have only one level in this demo)
}
function main()
{
	video_window(nullvector,nullvector,1,"Pacman.3d (demo) by Vadim647");//make the title (i'm not sure that)
	video_switch(8,0,1);fps_max = 60;	//set video mode and fps.
	vec_set(sky_color,vector(80,64,48));//make a balanced background
	pml_load("pack_lev1.mdl");			//call a load-level function
	while(1)
	{	//make a good-looking effect of zoomin-zoomout function
		camera_v = cycle(camera_v + time_step * 2,0,360);
		camera.arc = 60 + cos(camera_v) * 5;
		wait(1);
	}
}